#include <Servo.h> 
/***********************************************************************/
Servo           monServo;
int             milieu         = 1500;
int             ampli          = 0;
int             pas            = 0;
int             Dt             = 20;
long            poolInterval   = 20;
long            previousMillis = 0;
unsigned long   currentMillis  = 0.0;
int             servoPos       = 0;
boolean         servoDirect    = true;
String          bufferStr      = "";
/***********************************************************************/
void setup()
{
  monServo.attach(9);
  servoPos = milieu - ampli;
  Serial.begin(9600);
}
/***********************************************************************/
void updateMyServo()
{
  if (servoDirect)
  {
    servoPos = servoPos + pas;
    if (servoPos > milieu + ampli)
    {
      servoDirect = false;
    }
  }
  else
  {
    servoPos = servoPos - pas;
    if (servoPos < milieu - ampli)
    {
      servoDirect = true;
    }
  }
  monServo.writeMicroseconds(servoPos);
}
/***********************************************************************/
void readSerial()
{
  int car = Serial.read();
  if (car > -1)
  {
    if  (car == ';')
    {
      Serial.println(bufferStr);
      if (bufferStr == "*") // arret d'urgence
      {
        ampli = 0;
        pas = 0;
      }
      if (bufferStr[0] == 'a')
      {
        ampli =  bufferStr.substring(1).toInt();
      }
      if (bufferStr[0] == 'p')
      {
        pas =  bufferStr.substring(1).toInt();
      }
      bufferStr = "";
    }
    else
    {
      bufferStr = bufferStr + (char)car;
    }
  }
}
/***********************************************************************/
void loop()
{
  currentMillis = millis();
  if (currentMillis - previousMillis > poolInterval)
  {
    previousMillis = currentMillis;
    readSerial();
    updateMyServo();
  }
}
