#!/usr/bin/env python
# -*- coding: utf-8 -*-

import serial, time
from Tkinter import *


class TableSismoControle(Frame):
    portSerie = None
    amplitude = 0
    pas       = 0
    RUNNING = False
    varF = None
    varT = None

    def __init__(self,parent):
        Frame.__init__(self,parent)
        self.parent = parent
        self.parent.wm_title("Table Sismique")
        self.parent.geometry("220x400+200+100")
        self.initSerial()
        self.initGUI()

    def initSerial(self):
        self.portSerie = serial.Serial('/dev/ttyACM0',9600)
        time.sleep(2)

    def initGUI(self):
        self.pack(fill=BOTH,expand=1)

        self.boutonGo = Button(self, text="Go !",command=self.GO)
        self.boutonGo.place(x=10,y=10)

        self.boutonStop = Button(self, text="Stop !",command=self.STOP)
        self.boutonStop.place(x=10,y=50)

        self.amplitudeScale = Scale(self,label="Amplitude", from_=0, to=600, orient=HORIZONTAL)
        self.amplitudeScale.place(x=10,y=90,width=200)
        self.amplitudeScale.bind("<ButtonRelease-1>", self.miseAjour)

        self.pasScale = Scale(self,label="Pas", from_=0, to=60, orient=HORIZONTAL,command=self.miseAjour)
        self.pasScale.place(x=10,y=170,width=200)
        self.pasScale.bind("<ButtonRelease-1>", self.miseAjour)

        self.varF = StringVar()
        self.labF = Label(root, textvariable = self.varF,anchor="w")
        self.labF.place(x=10,y=300,width=200)

        self.varT = StringVar()
        self.labT = Label(root, textvariable = self.varT,anchor="w")
        self.labT.place(x=10,y=250,width=200)

    def miseAjour(self,event):
        #print event
        self.amplitude = self.amplitudeScale.get()
        self.pas = self.pasScale.get()
        if self.RUNNING:
			self.GO()

    def GO(self):
        self.RUNNING = True
        self.portSerie.write("a"+str(self.amplitude)+";p"+str(self.pas)+";")
        self.varF.set("Fréquence: "+"{:10.2f}".format(self.pas/(self.amplitude * 0.020*4))+" Hz")
        self.varT.set("Période: "+"{:10.2f}".format((self.amplitude * 0.020*4)/self.pas)+" s")

    def STOP(self):
        self.RUNNING = False
        self.portSerie.write("a0;p0;")
        self.portSerie.write("*;")


if __name__ == "__main__":
    root = Tk()
    app = TableSismoControle(root)
    root.mainloop()

